--(C)Chris Onderwater 2011. All rights reserved on all work in the .love file.
--(borrowing pieces of code is permitted, if you use it for a great game)


--Mostly loads modules, checks gamestates, handles keypresses

--Frame buffer and resolutions should be handled here too.


require 'middleclass'
HC = require 'hardoncollider'
HC.init(100, on_collide)
require 'particles.lua'
require 'helpers.lua'
require 'game.lua'
require 'menu.lua'
require 'play.lua'
require 'objects.lua'



--Game logic.
--load
function love.load()
--Do the resolution thing.
local modes = love.graphics.getModes()
screen = {x=modes[1].width, y=modes[1].height}
love.graphics.setMode(screen.x, screen.y, true, true, 0)

-- -------------

game:init()
playplay = play:new()
menumenu = menu:new()
end

--draw
function love.draw()
-- Scale the game so it works in every resolution.
love.graphics.scale(screen.x/1280,screen.y/1024)

-- -----
if game.state==game.play then
playplay:draw()
else 
menumenu:draw()
end
local xx,yy = love.mouse.getPosition()

end

--update
function love.update(dt)

if game.state==game.play then
playplay:update(dt)
else
menumenu:update()
end
end



--MAINLY debugging and handling keypresses
function love.keypressed(key, u)
   --Debug
   if key == "rctrl" then --set to whatever key you want to use
      debug.debug()
   end
   if key == 'escape' then
love.event.push('q')
end

if key=='2' then
loadlvl(2)
end
if key=='3' then
loadlvl(3)
end
if key=='4' then
loadlvl(4)
end
if key=='5' then
loadlvl(5)
end
end







