--mostly initializes levels, executes main loop, calls the functions of objects. 

require 'middleclass.lua'
HC = require 'hardoncollider'
require 'game.lua'

--level 1
play = class('play')
function play:initialize()
messages = msg:new()
lives = livesbar:new()
particles = PP:new(500,500)
Items={}
bricks={}
bricks[1]=brick:new(215,220)
bricks[2]=brick:new(350,220)
bricks[3]=brick:new(500,220)
bricks[4]=brick:new(650,220)
bricks[5]=brick:new(800,220)
bricks[6]=brick:new(950,220)
bricks[7]=brick:new(215,400)
bricks[8]=brick:new(350,400)
bricks[9]=brick:new(500,400)
bricks[10]=brick:new(650,400)
bricks[11]=brick:new(800,400)
bricks[12]=brick:new(950,400)

ballball=ball:new(600,600)
bat=paddle:new(200,950)
--initialize wallobjects 
wallright = HC.addRectangle(1130,0,150,1024)
wallright.x = 1130
wallright.y= 0

wallup=HC.addRectangle(0,0,1280,170)
wallup.x=0
wallup.y=0

wallleft=HC.addRectangle(0,0,105,1280)
wallleft.x=0
wallleft.y=0
background = love.graphics.newImage('background.png')
background_sound = love.audio.newSource('song_1.ogg')
background_sound:setLooping(true)
love.audio.play(background_sound)
end

function play:draw()
--draw regular objects that always exist
love.graphics.draw(background,0,0)
 ballball:draw()
messages:draw()
bat:draw()
lives:draw()
love.graphics.draw(particles_fire)
--Draw all bricks
local x
for x in pairs(bricks) do
    bricks[x]:draw()
end
--draw all Items
local x
for x in pairs(Items) do
Items[x]:draw()
end
end


function play:update(dt)
ballball:move(dt)
bat:move(dt)
particles:update(dt)
--check for collissions
if ballball.box:collidesWith(bat.box) then
ballball.yto = (-1)
end
if wallright:collidesWith(ballball.box) then
ballball.xto=(-1)
end
if wallup:collidesWith(ballball.box) then
ballball.yto=1
end
if wallleft:collidesWith(ballball.box) then
ballball.xto=1
end

--collisions with bricks
local x
for x in pairs(bricks) do
if ballball.box:collidesWith(bricks[x].box) then
ballball:bounce(bricks[x].xx,bricks[x].yy)
bricks[x]:doStuff()
table.remove(bricks,x)
end
end

--Check if all bricks are kaduuk
if table.getn(bricks)==0 then
game:nextlvl()
end
--Check for items
local x
for x in pairs(Items) do
Items[x]:update(dt)
end


--Hmm. Maybe..... The ball will get outofthescreen:O AND WHAT THEN??? this:
if ballball.y > 1024 then
lives.lives = lives.lives-1
ballball=nil
ballball = ball:new(600,600)
--why this way? so you can implent in the ball loader, that the ball waits before coming ingame. 
end
--hmm. But what if... all lives are gone :O
if lives.lives < 1 then
messages:addMsg('GAME OVER (not yet implented but you fail)')
--game over.
end

end


function loadlvl(level)
if level == 2 then 
messages:addMsg('LEVEL 2')
--delete objects


bricks=nil
bricks={}
bricks[1]=brick2:new(100,250,1)
bricks[2]=brick:new(200,250)
bricks[3]=brick:new(300,250)
bricks[4]=brick:new(400,250)
bricks[5]=brick:new(500,250)
bricks[6]=brick:new(600,250)
bricks[7]=brick:new(700,250)
bricks[8]=brick:new(800,250)
bricks[9]=brick:new(900,250)
bricks[10]=brick:new(1000,250)
bricks[11]=brick:new(100,500)
bricks[12]=brick:new(200,500)
bricks[13]=brick:new(300,500)
bricks[14]=brick:new(400,500)
bricks[15]=brick2:new(500,500,2)
bricks[16]=brick:new(600,500)
bricks[17]=brick:new(700,500)
bricks[18]=brick:new(800,500)
bricks[19]=brick:new(900,500)
bricks[20]=brick:new(1000,500)


ballball=nil
ballball=ball:new(600,600)
end
if level == 3 then 
messages:addMsg('LEVEL 3')
--delete objects


bricks=nil
Items=nil
bricks={}
Items={}
bricks[1]=brick2:new(100,250,1)
bricks[2]=brick:new(300,250)
bricks[3]=brick:new(500,250)
bricks[4]=brick:new(700,250)
bricks[5]=brick:new(900,250)
bricks[6]=brick2:new(100,500,2)
bricks[7]=brick2:new(300,500,2)
bricks[8]=brick2:new(500,500,2)
bricks[9]=brick2:new(700,500,2)
bricks[10]=brick2:new(900,500,2)



ballball=nil
ballball=ball:new(600,600)
end
if level == 4 then 
messages:addMsg('LEVEL 4')
--delete objects


bricks=nil
Items=nil
bricks={}
Items={}
bricks[1]=brick2:new(100,250,1)
bricks[2]=brick:new(300,250)
bricks[3]=brick:new(500,250)
bricks[4]=brick:new(700,250)
bricks[5]=brick:new(900,250)
bricks[6]=brick2:new(100,500,2)
bricks[7]=brick2:new(300,500,2)
bricks[8]=brick2:new(500,500,2)
bricks[9]=brick2:new(700,500,2)
bricks[10]=brick2:new(900,500,2)
bricks[11]=brick:new(100,700)
bricks[12]=brick:new(200,700)
bricks[13]=brick:new(300,700)
bricks[14]=brick:new(400,700)
bricks[15]=brick:new(500,700)
bricks[16]=brick:new(600,700)
bricks[17]=brick:new(700,700)
bricks[18]=brick:new(800,700)
bricks[19]=brick:new(900,700)




ballball=nil
ballball=ball:new(600,600)
end
if level == 5 then 
messages:addMsg('LEVEL 5')
--delete objects

bricks=nil
Items=nil
bricks={}
Items={}
bricks[1]=brick2:new(100,250,2)
bricks[2]=brick2:new(300,250,2)
bricks[3]=brick2:new(500,250,1)
bricks[4]=brick2:new(700,250,2)
bricks[5]=brick2:new(900,250,1)
bricks[6]=b_brick:new(150,500)
bricks[7]=b_brick:new(300,500)
bricks[8]=b_brick:new(450,500)
bricks[9]=b_brick:new(600,500)
bricks[9]=b_brick:new(750,500)
bricks[10]=brick:new(900,500)
bricks[11]=brick:new(100,550)
bricks[12]=brick:new(200,550)
bricks[13]=brick:new(300,550)
bricks[14]=brick:new(400,550)
bricks[15]=brick:new(500,550)
bricks[16]=brick:new(600,550)
bricks[17]=brick:new(700,550)
bricks[18]=brick:new(800,550)
bricks[19]=brick:new(900,550)




ballball=nil
ballball=ball:new(600,600)
end
end
